#ifndef mean_H
#define mean_H

#include "fvCFD.H"

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

tmp<volScalarField> mean(const volScalarField& unFilteredField)
{
       const fvMesh& mesh = unFilteredField.mesh();
           return fvc::surfaceSum(mesh.magSf()*fvc::interpolate(unFilteredField))
                         /fvc::surfaceSum(mesh.magSf());
}

tmp<volVectorField> mean(const volVectorField& unFilteredField)
{
       const fvMesh& mesh = unFilteredField.mesh();
           return  fvc::surfaceSum(mesh.magSf()*fvc::interpolate(unFilteredField))
                         /fvc::surfaceSum(mesh.magSf());
}

tmp<volTensorField> mean(const volTensorField& unFilteredField)
{
       const fvMesh& mesh = unFilteredField.mesh();
           return fvc::surfaceSum(mesh.magSf()*fvc::interpolate(unFilteredField))
                         /fvc::surfaceSum(mesh.magSf());
}


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#endif

