{
    volScalarField rUA = 1.0/UEqn.A();
    surfaceScalarField rUAf = fvc::interpolate(rUA);

    U = rUA*UEqn.H();

    surfaceScalarField phiU
    (
        "phiU",
        (fvc::interpolate(U) & mesh.Sf())
      + fvc::ddtPhiCorr(rUA, rho, U, phi)
    );

    
    phi = phiU;/* +
        (
            fvc::interpolate(interface.sigmaK())*fvc::snGrad(gamma)
          - ghf*fvc::snGrad(rho)
        )*rUAf*mesh.magSf();
    */
    adjustPhi(phi, U, pd);

    //Pair<tmp<volScalarField> > vDotP = twoPhaseProperties->vDotP();
    //vDotP[0]().max(dimensionedScalar("zero", vDotP[0]().dimensions(), 0.0));
    //vDotP[1]().min(dimensionedScalar("zero", vDotP[1]().dimensions(), 0.0));
    /*
    const volScalarField& vDotcP = vDotP[0]();
    const volScalarField& vDotvP = vDotP[1]();
    */

    Pair<tmp<volScalarField> > vDotP = twoPhaseProperties->vDotP();
    vDotcP = vDotP[0]();
    vDotvP = vDotP[1]();

    Info << "Max vDotcP: " << max(vDotcP).value() << "    Min vDotcP: " << min(vDotcP).value() << endl;
    Info << "Max vDotvP: " << max(vDotvP).value() << "    Min vDotvP: " << min(vDotvP).value() << endl;

    for(int nonOrth=0; nonOrth<=nNonOrthCorr; nonOrth++)
    {
        fvScalarMatrix pdEqn
        (
            fvc::div(phi) - fvm::laplacian(rUAf, pd)
	    //- vDotcP + vDotvP*(rho*gh - pSat) + fvm::Sp(vDotvP, pd)
	    + (vDotvP - vDotcP)*(rho*gh - pSat) + fvm::Sp(vDotvP - vDotcP, pd)
        );

        pdEqn.setReference(pdRefCell, pdRefValue);

        if (corr == nCorr-1 && nonOrth == nNonOrthCorr)
        {
            pdEqn.solve(mesh.solver(pd.name() + "Final"));
        }
        else
        {
            pdEqn.solve(mesh.solver(pd.name()));
        }

        if (nonOrth == nNonOrthCorr)
        {
            phi += pdEqn.flux();
        }
    }

    p = pd + rho*gh;

    U += rUA*fvc::reconstruct((phi - phiU)/rUAf);
    U.correctBoundaryConditions();
}
