nu = twoPhaseProperties->nu();

    scalar kappa = 0.42;
    scalar B = 5.4366;

    scalar maxYplus = 0;
    scalar minYplus = 1.0e9;

    scalar Y;
scalar NU ;
    scalar U1;

    const fvPatchList& patches = mesh.boundary();

    forAll (patches, patchi)
    {
        const fvPatch& currPatch = patches[patchi];

        if (isType<wallFvPatch>(currPatch))
        {
            Info << "Modifying wall viscosity at patch "<< currPatch.name() << endl;

            scalarField &ypatch = y[patchi];
            forAll(currPatch, facei)
            {
                 label faceCelli = currPatch.faceCells()[facei];

                 //Y = y[faceCelli];
                 Y = ypatch[facei];
                 NU = nu[faceCelli];
                 U1 = mag( U[faceCelli] - U.boundaryField()[patchi][facei]);

                 if ( U1 > 0)
                 {
                     scalar nuEffOld = nuEff[faceCelli];
                     //scalar kOld = k[faceCelli];

                     // yPlus < 11.225
                     scalar utau = Foam::sqrt( U1 * NU/Y);
                     scalar yPlus = utau*Y/NU;

                     if (yPlus > maxYplus) maxYplus = yPlus;
                     if (yPlus < minYplus) minYplus = yPlus;
		     /*
		     if (wallFunction == "WALL_VISCOSITY")
		       {
                     // 11.225 >= yPlus < 500
                     if ((yPlus >= 11.225) && (yPlus < 500))
                     {
                         scalar utauOld = utau + 0.001;
                         while (mag(utau - utauOld) > 1.0e-06)
                         {
                             utauOld = utau;

                             utau = utauOld +
                                    (
                                       kappa*utauOld*U1
                                     - (utauOld*utauOld)
                                     * Foam::log(utauOld*Y/NU)
                                     - kappa*B*utauOld*utauOld
                                    ) / (utauOld + kappa*U1);
                         }
                         yPlus = utau*Y/NU;

                         if (yPlus > maxYplus) maxYplus = yPlus;
                         if (yPlus < minYplus) minYplus = yPlus;
                     }
                     nuEff[faceCelli] = utau*utau*Y/U1;
                     //k[faceCelli] = 0.5*utau*utau;

                     // yPlus >= 500
                     if (yPlus >= 500)
                     {
                          nuEff[faceCelli] = nuEffOld;
                          //k[faceCelli] = kOld;
                     }
                     }
		     else if (wallFunction == "SPALDING_WALL_VISCOSITY")
		       {
		     */
                     if ( yPlus < 500)
                     {

		       scalar UPlus;
		       scalar kUp;
		       scalar A = 5.1;
		       scalar A1 = 1.0/Foam::exp(kappa*A);
		       scalar fuTau, fpuTau;
		       
                         scalar utauOld = utau + 0.001;
                         while (mag(utau - utauOld) > 1.0e-06)
                         {
			     UPlus = U1/utau;
			     kUp = kappa*UPlus;
			     fuTau = UPlus + A1*(Foam::exp(kUp)-(1+kUp+kUp*kUp/2.0+kUp*kUp*kUp/3.0))-yPlus;
			     fpuTau = Y/NU + (UPlus + A1*(kUp*Foam::exp(kUp)-(kUp+kUp*kUp+kUp*kUp*kUp)))/utau;

                             utauOld = utau;
                             utau = utauOld + fuTau/fpuTau;

                         }
                         yPlus = utau*Y/NU;

                         if (yPlus > maxYplus) maxYplus = yPlus;
                         if (yPlus < minYplus) minYplus = yPlus;
                     }
                     nuEff[faceCelli] = utau*utau*Y/U1;
                     //k[faceCelli] = 0.5*utau*utau;

                     // yPlus >= 500
                     if (yPlus >= 500)
                     {
                          nuEff[faceCelli] = nuEffOld;
                          //k[faceCelli] = kOld;
                     }
		     //}
		     yp.boundaryField()[patchi][facei] = yPlus;
		     uTau.boundaryField()[patchi][facei] = utau;
		     wallShearStress.boundaryField()[patchi][facei] = sqr(utau)*U[faceCelli] /(mag( U[faceCelli])+1e-5);
	    }
            }
        }
    }
    nuEff.correctBoundaryConditions();
//k.correctBoundaryConditions();


